Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsGeneral.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsGeneral.cpp	(revision 85848)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsGeneral.cpp	(revision 85849)
@@ -653,5 +653,5 @@
             {
                 m_pLabelSnapshotFolder->setAlignment(Qt::AlignRight | Qt::AlignVCenter);
-                pLayoutAdvanced->addWidget(m_pLabelSnapshotFolder, 0, 0, 1, 1);
+                pLayoutAdvanced->addWidget(m_pLabelSnapshotFolder, 0, 0);
             }
             /* Prepare snapshot folder editor: */
@@ -669,5 +669,5 @@
             {
                 m_pLabelClipboard->setAlignment(Qt::AlignRight | Qt::AlignVCenter);
-                pLayoutAdvanced->addWidget(m_pLabelClipboard, 1, 0, 1, 1);
+                pLayoutAdvanced->addWidget(m_pLabelClipboard, 1, 0);
             }
             /* Prepare clipboard combo: */
@@ -677,5 +677,5 @@
                 if (m_pLabelClipboard)
                     m_pLabelClipboard->setBuddy(m_pComboClipboard);
-                pLayoutAdvanced->addWidget(m_pComboClipboard, 1, 1, 1, 1);
+                pLayoutAdvanced->addWidget(m_pComboClipboard, 1, 1);
             }
 
@@ -685,5 +685,5 @@
             {
                 m_pLabelDragAndDrop->setAlignment(Qt::AlignRight | Qt::AlignVCenter);
-                pLayoutAdvanced->addWidget(m_pLabelDragAndDrop, 2, 0, 1, 1);
+                pLayoutAdvanced->addWidget(m_pLabelDragAndDrop, 2, 0);
             }
             /* Prepare drag&drop combo: */
@@ -693,5 +693,5 @@
                 if (m_pLabelDragAndDrop)
                     m_pLabelDragAndDrop->setBuddy(m_pComboDragAndDrop);
-                pLayoutAdvanced->addWidget(m_pComboDragAndDrop, 2, 1, 1, 1);
+                pLayoutAdvanced->addWidget(m_pComboDragAndDrop, 2, 1);
             }
         }
@@ -749,5 +749,5 @@
             QSpacerItem *pSpacerItem = new QSpacerItem(20, 0, QSizePolicy::Fixed, QSizePolicy::Minimum);
             if (pSpacerItem)
-                pLayoutEncryption->addItem(pSpacerItem, 1, 0, 1, 1);
+                pLayoutEncryption->addItem(pSpacerItem, 1, 0);
 
             /* Prepare encryption settings widget: */
@@ -766,5 +766,5 @@
                     {
                         m_pLabelCipher->setAlignment(Qt::AlignRight|Qt::AlignVCenter);
-                        m_pLayoutEncryptionSettings->addWidget(m_pLabelCipher, 0, 0, 1, 1);
+                        m_pLayoutEncryptionSettings->addWidget(m_pLabelCipher, 0, 0);
                     }
                     /* Prepare encryption cipher combo: */
@@ -778,5 +778,5 @@
                         if (m_pLabelCipher)
                             m_pLabelCipher->setBuddy(m_pComboCipher);
-                        m_pLayoutEncryptionSettings->addWidget(m_pComboCipher, 0, 1, 1, 1);
+                        m_pLayoutEncryptionSettings->addWidget(m_pComboCipher, 0, 1);
                     }
 
@@ -786,5 +786,5 @@
                     {
                         m_pLabelEncryptionPassword->setAlignment(Qt::AlignRight|Qt::AlignVCenter);
-                        m_pLayoutEncryptionSettings->addWidget(m_pLabelEncryptionPassword, 1, 0, 1, 1);
+                        m_pLayoutEncryptionSettings->addWidget(m_pLabelEncryptionPassword, 1, 0);
                     }
                     /* Prepare encryption password editor: */
@@ -795,5 +795,5 @@
                         if (m_pLabelEncryptionPassword)
                             m_pLabelEncryptionPassword->setBuddy(m_pEditorEncryptionPassword);
-                        m_pLayoutEncryptionSettings->addWidget(m_pEditorEncryptionPassword, 1, 1, 1, 1);
+                        m_pLayoutEncryptionSettings->addWidget(m_pEditorEncryptionPassword, 1, 1);
                     }
 
@@ -803,5 +803,5 @@
                     {
                         m_pLabelEncryptionPasswordConfirm->setAlignment(Qt::AlignRight|Qt::AlignVCenter);
-                        m_pLayoutEncryptionSettings->addWidget(m_pLabelEncryptionPasswordConfirm, 2, 0, 1, 1);
+                        m_pLayoutEncryptionSettings->addWidget(m_pLabelEncryptionPasswordConfirm, 2, 0);
                     }
                     /* Prepare encryption confirm password editor: */
@@ -812,9 +812,9 @@
                         if (m_pLabelEncryptionPasswordConfirm)
                             m_pLabelEncryptionPasswordConfirm->setBuddy(m_pEditorEncryptionPasswordConfirm);
-                        m_pLayoutEncryptionSettings->addWidget(m_pEditorEncryptionPasswordConfirm, 2, 1, 1, 1);
+                        m_pLayoutEncryptionSettings->addWidget(m_pEditorEncryptionPasswordConfirm, 2, 1);
                     }
                 }
 
-                pLayoutEncryption->addWidget(m_pWidgetEncryptionSettings, 1, 1, 1, 1);
+                pLayoutEncryption->addWidget(m_pWidgetEncryptionSettings, 1, 1);
             }
         }
@@ -860,5 +860,4 @@
 void UIMachineSettingsGeneral::repopulateComboClipboardMode()
 {
-    /* Clipboard mode combo-box created in the .ui file. */
     AssertPtrReturnVoid(m_pComboClipboard);
     {
@@ -882,5 +881,4 @@
 void UIMachineSettingsGeneral::repopulateComboDnDMode()
 {
-    /* DnD mode combo-box created in the .ui file. */
     AssertPtrReturnVoid(m_pComboDragAndDrop);
     {